var load = false;

// Test
function drawFischka() {
    var fischka = new CFischka(100, 20, "Fischka-1", "canvas");
    fischka.draw();
}

// Class CFischka
function CFischka(x, y, name, context) {
    this.x = x;
    this.y = y;
    this.width = 150;
    this.height = 80;
    this.name = name;

    this.image_left = data_left;
    this.image_right = data_right;

    this.setLeftImage = function (left) {
        this.image_left = left;
    }

    this.setRightImage = function (right) {
        this.image_right = right;
    }
    
    this.draw = function() {
        thisObject = this;
    
        $(context).drawFischka({
            draggable: true,
            layer: true,
            bringToFront: false,
            x: thisObject.x,
            y: thisObject.y,
            width: thisObject.width,
            height: thisObject.height,
            image_left: thisObject.image_left,
            image_right: thisObject.image_right, 
            load_images: true,
            groups: [thisObject.name + '_shape'],
            dragGroups: [thisObject.name + '_shape'],
            dragstart: function (layer) {
                console.log('draggable Dragstart');
                thisObject.x = layer.x;
                thisObject.y = layer.y;

                layer.load_images = true;
            },
            drag: function (layer) {
                thisObject.x = layer.x;
                thisObject.y = layer.y;
            },
            dragstop: function (layer) {
                thisObject.x = layer.x;
                thisObject.y = layer.y;
            }
        });
        $(context).drawImage({
            draggable: true,
            bringToFront: true,
            groups: [thisObject.name + '_shape'],
            dragGroups: [thisObject.name + '_shape'],
            source: thisObject.image_left,
            x: thisObject.x + thisObject.width / 4, 
            y: thisObject.y + thisObject.height / 2 
        });
        $(context).drawImage({
            draggable: true,
            bringToFront: true,
            groups: [thisObject.name + '_shape'],
            dragGroups: [thisObject.name + '_shape'],
            source: thisObject.image_right,
            x: thisObject.x + 3*thisObject.width / 4, 
            y: thisObject.y + thisObject.height / 2 
        });
    }
}

// Zeichnen von Dominosteinen
// Рисовать фишки
$.jCanvas.extend({
    name: 'drawFischka',
    type: 'fischka',
    props: {
        load_images: true
    },
    fn: function(ctx, params) {
        var p = params;
        // Enable layer transformations like scale and rotate
        $.jCanvas.transformShape(this, ctx, p);
        // Draw FieldItem
        ctx.beginPath();
        
        ctx.fillStyle = '#f4f6f5';
        
        ctx.moveTo(p.x, p.y);
        ctx.lineTo(p.x + p.width-10, p.y);
        ctx.quadraticCurveTo(p.x + p.width, p.y, p.x + p.width, p.y + 10);
        ctx.lineTo(p.x + p.width, p.y + p.height - 10);
        ctx.quadraticCurveTo(p.x + p.width, p.y + p.height, p.x + p.width - 10, p.y + p.height);
        ctx.lineTo(p.x + 10, p.y + p.height);
        ctx.quadraticCurveTo(p.x, p.y + p.height, p.x, p.y + p.height - 10);
        ctx.lineTo(p.x, p.y + 10);
        ctx.quadraticCurveTo(p.x, p.y, p.x + 10, p.y); 
        
        ctx.fill();

        // #a3a5a4
        ctx.strokeStyle = '#a3a5a4';
        ctx.moveTo(p.x + p.width/2, p.y + 5);
        ctx.lineTo(p.x + p.width/2, p.y + p.height - 5);

        // Call the detectEvents() function to enable jCanvas events
        // Be sure to pass it these arguments, too!
        $.jCanvas.detectEvents(this, ctx, p);
        // Call the closePath() functions to fill, stroke, and close the path
        // This function also enables masking support and events
        // It accepts the same arguments as detectEvents()
        $.jCanvas.closePath(this, ctx, p);
    }
  });